<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Formatting for log records."><meta name="keywords" content="rust, rustlang, rust-lang, fmt"><title>env_logger::fmt - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/static/images/favicon.ico"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../env_logger/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../env_logger/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module fmt</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../env_logger/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">env_logger</a>::<wbr><a class="mod" href="#">fmt</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/env_logger/fmt/mod.rs.html#1-652">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Formatting for log records.</p>
<p>This module contains a <a href="struct.Formatter.html"><code>Formatter</code></a> that can be used to format log records
into without needing temporary allocations. Usually you won’t need to worry
about the contents of this module and can use the <code>Formatter</code> like an ordinary
<a href="https://doc.rust-lang.org/stable/std/io/trait.Write.html"><code>Write</code></a>.</p>
<h2 id="formatting-log-records"><a href="#formatting-log-records">Formatting log records</a></h2>
<p>The format used to print log records can be customised using the <a href="../struct.Builder.html#method.format"><code>Builder::format</code></a>
method.
Custom formats can apply different color and weight to printed values using
<a href="struct.Style.html"><code>Style</code></a> builders.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">std::io::Write</span>;

<span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">builder</span> <span class="op">=</span> <span class="ident">env_logger::Builder::new</span>();

<span class="ident">builder</span>.<span class="ident">format</span>(<span class="op">|</span><span class="ident">buf</span>, <span class="ident">record</span><span class="op">|</span> {
    <span class="macro">writeln!</span>(<span class="ident">buf</span>, <span class="string">&quot;{}: {}&quot;</span>,
        <span class="ident">record</span>.<span class="ident">level</span>(),
        <span class="ident">record</span>.<span class="ident">args</span>())
});</code></pre></div>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Formatter.html" title="env_logger::fmt::Formatter struct">Formatter</a></div><div class="item-right docblock-short"><p>A formatter to write logs into.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Style.html" title="env_logger::fmt::Style struct">Style</a></div><div class="item-right docblock-short"><p>A set of styles to apply to the terminal output.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.StyledValue.html" title="env_logger::fmt::StyledValue struct">StyledValue</a></div><div class="item-right docblock-short"><p>A value that can be printed using the given styles.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Timestamp.html" title="env_logger::fmt::Timestamp struct">Timestamp</a></div><div class="item-right docblock-short"><p>An <a href="https://www.ietf.org/rfc/rfc3339.txt">RFC3339</a> formatted timestamp.</p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Color.html" title="env_logger::fmt::Color enum">Color</a></div><div class="item-right docblock-short"><p>The set of available colors for the terminal foreground/background.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Target.html" title="env_logger::fmt::Target enum">Target</a></div><div class="item-right docblock-short"><p>Log target, either <code>stdout</code>, <code>stderr</code> or a custom pipe.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.TimestampPrecision.html" title="env_logger::fmt::TimestampPrecision enum">TimestampPrecision</a></div><div class="item-right docblock-short"><p>Formatting precision of timestamps.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.WriteStyle.html" title="env_logger::fmt::WriteStyle enum">WriteStyle</a></div><div class="item-right docblock-short"><p>Whether or not to print styles to the target.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="env_logger" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>